### MARS

# install.packages("mda")
library(mda)
data(trees)

attach(trees)

postscript("mars.data.ps",horizontal=F)
par(las=1,pty="m")
pairs(trees,panel=panel.smooth,main="")
dev.off()

postscript("mars.bf.ps")
par(mfrow=c(1,1))
plot(c(0,1),c(0,0.5),xlab="x",ylab="Basis Function",xaxt="n",yaxt="n",type="n")
lines(c(0,0.5),c(0,0),col="red",lwd=2)
lines(c(0.5,1),c(0,0.5),col="red",lwd=2)
lines(c(0,0.5),c(0.5,0),col="springgreen4",lty=2,lwd=2)
lines(c(0.5,1),c(0,0),col="springgreen4",lty=2,lwd=2)
axis(1,0.5,"t")
text(0.7,0.35,expression("( x - t )+"),col="red",cex=2)
text(0.3,0.35,expression("( t - x )+"),col="springgreen4",cex=2)
dev.off()


mbf=function(x,y,rd){
plot(c(0,1),c(0,max(y)+0.5),xlab="",ylab="",xaxt="n",yaxt="n",type="n")
for(i in x){
for(k in y){
lines(c(i-0.1,i),k+c(0,0),col="blue",lwd=2)
lines(c(i,i+0.1),k+c(0,0.5),col="blue",lwd=2)
lines(c(i-0.1,i),k+c(0.5,0),col="blue",lty=2,lwd=2)
lines(c(i,i+0.1),k+c(0,0),col="blue",lty=2,lwd=2)}}
if(!missing(rd)){
print(rd)
if(is.vector(rd)){
i=x[rd[1]]
k=y[rd[2]]
print("lala")
lines(c(i-0.1,i),k+c(0,0),col="red",lwd=2)
lines(c(i,i+0.1),k+c(0,0.5),col="red",lwd=2)
lines(c(i-0.1,i),k+c(0.5,0),col="red",lty=2,lwd=2)
lines(c(i,i+0.1),k+c(0,0),col="red",lty=2,lwd=2)}
else{
for(j in 1:nrow(rd)){
i=x[rd[j,1]]
k=y[rd[j,2]]
print(c(i,k))
lines(c(i-0.1,i),k+c(0,0),col="red",lwd=2)
lines(c(i,i+0.1),k+c(0,0.5),col="red",lwd=2)
lines(c(i-0.1,i),k+c(0.5,0),col="red",lty=2,lwd=2)
lines(c(i,i+0.1),k+c(0,0),col="red",lty=2,lwd=2)}}}}


postscript("mars.cand.1.ps")
par(las=1,cex.axis=1.4)
mbf(seq(0.1,0.9,0.25),0:3,c(3,3))
axis(4,3.25,expression(X[1]))
axis(4,2.25,expression(X[2]))
axis(4,1.25,expression(X[3]))
axis(4,0.25,expression(X[4]))
dev.off()

postscript("mars.cand.2.ps")
par(las=1,cex.axis=1.4)
mbf(seq(0.1,0.9,0.25),0:3,c(2,4))
axis(4,3.25,expression(X[1]))
axis(4,2.25,expression(X[2]))
axis(4,1.25,expression(X[3]))
axis(4,0.25,expression(X[4]))
dev.off()

postscript("mars.cand.3.ps")
par(las=1,cex.axis=1.4)
mbf(seq(0.1,0.9,0.25),0:3,c(4,1))
axis(4,3.25,expression(X[1]))
axis(4,2.25,expression(X[2]))
axis(4,1.25,expression(X[3]))
axis(4,0.25,expression(X[4]))
dev.off()

postscript("mars.sel.1.ps")
par(las=1,cex.axis=1.4)
plot(c(0,1),c(0,0.5),xlab="",ylab="",xaxt="n",yaxt="n",type="n")
lines(c(0,1),c(0.25,0.25),col="red",lwd=2)
dev.off()

postscript("mars.sel.2.ps")
par(las=1,cex.axis=1.4)
plot(c(0,1),c(0,0.5),xlab="",ylab="",xaxt="n",yaxt="n",type="n")
lines(c(0,1),c(1/3,1/3),col="red",lwd=2)
lines(c(0,0.75),c(1/6,1/6),col="blue",lwd=2)
lines(c(0.75,1),c(1/6,1/6+1/8),col="blue",lwd=2)
lines(c(0.5,0.75),c(1/6+1/8,1/6),col="blue",lty=2,lwd=2)
lines(c(0.75,1),c(1/6,1/6),col="blue",lty=2,lwd=2)
axis(4,1/6,expression(X[2]))
dev.off()

postscript("mars.sel.3.ps")
par(las=1,cex.axis=1.4)
plot(c(0,1),c(0,0.5),xlab="",ylab="",xaxt="n",yaxt="n",type="n")
lines(c(0,1),c(12/30,12/30),col="blue",lwd=2)
lines(c(0,0.75),c(7/30,7/30),col="red",lwd=2)
lines(c(0.75,1),c(7/30,7/30+1/10),col="red",lwd=2)
lines(c(0.5,0.75),c(7/30+1/10,7/30),col="red",lty=2,lwd=2)
lines(c(0.75,1),c(7/30,7/30),col="red",lty=2,lwd=2)
lines(c(0,0.25),c(2/30,2/30),col="blue",lwd=2)
lines(c(0.25,0.5),c(2/30,2/30+1/10),col="blue",lwd=2)
lines(c(0,0.25),c(2/30+1/10,2/30),col="blue",lty=2,lwd=2)
lines(c(0.25,1),c(2/30,2/30),col="blue",lty=2,lwd=2)
axis(4,7/30,expression(X[2]))
axis(4,2/30,expression(X[1]))
dev.off()




# from the MARS helpfile
showcuts = function(obj)
{
  tmp = obj$cuts[obj$sel, ]
  dimnames(tmp) = list(NULL, names(trees)[-3])
  tmp
}

# this function projects 3D points onto a 2D plot
trans3d=function(x,y,z,pmat){
  tr=cbind(x,y,z,1) %*% pmat
  list(x = tr[,1]/tr[,4], y= tr[,2]/tr[,4])}

fit1=mars(trees[,-3],trees[3])
showcuts(fit1)

x1=seq(8,21,length=21);x2=seq(60,90,length=21);x=expand.grid(x1,x2)
xprd=matrix(predict(fit1,x),ncol=21)

persp(x1,x2,xprd,theta=30,phi=30,expand=0.8,col="lightblue",
xlab="girth",ylab="height",zlab="volume") -> theplot

par(mfrow=c(2,4),mar=rep(2,4))
persp(x1,x2,xprd,theta=0,phi=30,expand=0.8,col="lightblue",
xlab="girth",ylab="height",zlab="volume") -> theplot
persp(x1,x2,xprd,theta=90,phi=30,expand=0.8,col="lightblue",
xlab="girth",ylab="height",zlab="volume") -> theplot
persp(x1,x2,xprd,theta=180,phi=30,expand=0.8,col="lightblue",
xlab="girth",ylab="height",zlab="volume") -> theplot
persp(x1,x2,xprd,theta=270,phi=30,expand=0.8,col="lightblue",
xlab="girth",ylab="height",zlab="volume") -> theplot
persp(x1,x2,xprd,theta=0,phi=0,expand=0.8,col="lightblue",
xlab="girth",ylab="height",zlab="volume") -> theplot
persp(x1,x2,xprd,theta=90,phi=0,expand=0.8,col="lightblue",
xlab="girth",ylab="height",zlab="volume") -> theplot
persp(x1,x2,xprd,theta=180,phi=0,expand=0.8,col="lightblue",
xlab="girth",ylab="height",zlab="volume") -> theplot
persp(x1,x2,xprd,theta=270,phi=0,expand=0.8,col="lightblue",
xlab="girth",ylab="height",zlab="volume") -> theplot

postscript("mars.fit.1.ps")
par(mfrow=c(1,3),mar=rep(2,4))
persp(x1,x2,xprd,theta=0,phi=30,expand=0.8,col="lightblue",
xlab="girth",ylab="height",zlab="volume") -> theplot
persp(x1,x2,xprd,theta=270,phi=0,expand=0.8,col="lightblue",
xlab="girth",ylab="height",zlab="volume") -> theplot
persp(x1,x2,xprd,theta=30,phi=30,expand=0.8,col="lightblue",
xlab="girth",ylab="height",zlab="volume") -> theplot
dev.off()

postscript("mars.fit.1a.ps")
persp(x1,x2,xprd,theta=0,phi=30,expand=0.8,col="lightblue",
xlab="girth",ylab="height",zlab="volume") -> theplot
dev.off()
postscript("mars.fit.1b.ps")
persp(x1,x2,xprd,theta=270,phi=0,expand=0.8,col="lightblue",
xlab="girth",ylab="height",zlab="volume") -> theplot
dev.off()
postscript("mars.fit.1c.ps")
persp(x1,x2,xprd,theta=30,phi=30,expand=0.8,col="lightblue",
xlab="girth",ylab="height",zlab="volume") -> theplot
dev.off()

# this is from the MARS help file
Xp = matrix(sapply(trees[1:2], mean), nrow(trees), 2, byrow=TRUE)
xr = sapply(trees, range)

postscript("mars.spline1.ps")
Xp1 = Xp; Xp1[,1] = seq(xr[1,1], xr[2,1], len=nrow(trees))
Xf = predict(fit1, Xp1)
par(las=1)
plot(Xp1[ ,1], Xf, xlab=names(trees)[1], ylab="", type="l")
dev.off()

postscript("mars.spline2.ps")
Xp1 = Xp; Xp1[,2] = seq(xr[1,2], xr[2,2], len=nrow(trees))
Xf = predict(fit1, Xp1)
par(las=1)
plot(Xp1[ ,2], Xf, xlab=names(trees)[2], ylab="", type="l")
dev.off()


### boosting

nc=10;nr=12000
X=matrix(rnorm(nc*nr),ncol=nc,nrow=nr)
Y=rep(-1,nr)
Y[apply(X,1,function(x) sum(x^2))>qchisq(0.5,10)]=1
dat=data.frame(cbind(y=Y,X))
names(dat)[2:11]=paste("X",1:10,sep="")
dat$y=factor(dat$y)

dat1=dat[1:2000,]
dat2=dat[2001:12000,]

tree1=tree(y~.,data=dat1)
tree2=prune.tree(tree1,best=2)
1-(1845*0.522+155*0.8452)/2000

tree3=tree(y~.,data=dat1,minsize=2,mindev=0)
summary(tree3)

test=predict(tree3,dat2)
py=rep(-1,10000)
py[test[,2]==1]=1
1-sum(diag(table(py,dat2$y)))/10000
# 0.2387

tree3.cv=cv.tree(tree3)
plot(tree3.cv)
tree4=prune.tree(tree3,best=50)
tree4.cv=cv.tree(tree4)
plot(tree4.cv)
tree5=prune.tree(tree3,best=20)
test=predict(tree5,dat2)
py=rep(-1,10000)
py[test[,2]>0.5]=1
1-sum(diag(table(py,dat2$y)))/10000
# 0.2591

mdat=dat1
mdat2=dat2
mdaty=rep(-1,2000);mdaty[mdat$y=="1"]=1
mdat2y=rep(-1,10000);mdat2y[mdat2$y=="1"]=1

wgts=rep(1,2000)

nit=100
mtree.list=as.list(1:nit)
mpr.train=as.list(1:nit)
mpr.test=as.list(1:nit)
malphas=rep(0,nit)

for(j in 1:nit){
cat(j,".. ")
mtree=rpart(y~.,data=mdat,weights=wgts)
mcp=mtree$cptable[2,1]
mtree=prune.rpart(mtree,cp=mcp)
mtree.list[[j]]=mtree
mpr=predict(mtree,mdat)
mpr2=predict(mtree,mdat2)
py=rep(-1,2000)
py2=rep(-1,10000)
py[mpr[,2]>0.5]=1
py2[mpr2[,2]>0.5]=1
mpr.train[[j]]= py
mpr.test[[j]]= py2
id=rep(1,2000)
id[(py-mdaty)==0]=0
err=sum(wgts*id)/sum(wgts)
alpha=log((1-err)/err)
malphas[j]=alpha
wgts=wgts*exp(alpha*id)
wgts=wgts/mean(wgts)
}

mprfinal=rep(0,10000)
for(j in 1:nit){mprfinal=mprfinal+malphas[j]*mpr.test[[j]]}
mprfinal=ifelse(mprfinal>0,1,-1)
1-sum(diag(table(mprfinal,mdat2y)))/10000

yy=rep(0,nit)
for(k in 1:nit){
mprfinal=rep(0,10000)
for(j in 1:k){mprfinal=mprfinal+malphas[j]*mpr.test[[j]]}
mprfinal=ifelse(mprfinal>0,1,-1)
yy[k]=1-sum(diag(table(mprfinal,mdat2y)))/10000}


mtree=rpart(y~.,data=dat1)
mcp=mtree$cptable[2,1]
mtree=prune.rpart(mtree,cp=mcp)
mpr2=predict(mtree,mdat2)
py2=rep(-1,10000)
py2[mpr2[,2]>0.5]=1
v1=1-sum(diag(table(py2,dat2$y)))/10000

mtree=rpart(y~.,data=dat1,cp=0.000001)
wh=order(mtree$cptable[,4])[1]
mcp=mtree$cptable[wh,1]
mtree=prune.rpart(mtree,cp=mcp)
mpr2=predict(mtree,mdat2)
py2=rep(-1,10000)
py2[mpr2[,2]>0.5]=1
v2=1-sum(diag(table(py2,dat2$y)))/10000


postscript("boost.scores.ps")
par(las=1)
plot(c(0,100),c(0,0.5),xlab="Boosting Iteration",ylab="Test Error",type="n")
abline(h=v1,lty=2,col="springgreen4")
abline(h=v2,lty=2,col="springgreen4")
lines(1:100,yy,col="red",lwd=2)
text(50,v1+0.01,"Single Stump",col="springgreen4")
text(50,v2+0.01,"Optimal Single Tree",col="springgreen4")
dev.off()


### bagging


myrmvn=function(mu,sigma,hm=1,...){
n=length(mu)
if(sum((dim(sigma)-rep(n,2))^2)!=0) 
stop("Check the dimensions of mu and sigma!")
if(det(sigma)==0) stop("The covariance matrix is singular!")
a=t(chol(sigma))
z=matrix(rnorm(n*hm),nrow=n)
y=t(a%*%z+mu)
return(y)}

mu=rep(0,5)
sigma=matrix(0.95,5,5)+diag(0.05,5)
X=data.frame(myrmvn(mu,sigma,2030))
round(cor(X),2)

wh1=(1:2030)[X[,1]<=0.5]
wh2=(1:2030)[X[,1]>0.5]
Y=rnorm(2030)
Y[wh1]=Y[wh1]+2
Y[wh2]=Y[wh2]-2
hist(Y,breaks=51)

wh1=(1:30)[X[,1]<=0.5]
wh2=(1:30)[X[,1]>0.5]

postscript("bagg.ex.1.ps")
par(mfrow=c(1,1),las=1,cex.axis=1.5,cex.lab=2)
plot(X[1:30,1],Y[1:30],xlab=expression(X[1]),ylab="Y",type="n")
points(X[wh1,1],Y[wh1],col="red",pch=16,cex=1.5)
points(X[wh2,1],Y[wh2],col="springgreen4",pch=16,cex=1.5)
dev.off()

postscript("bagg.ex.2.ps")
par(mfrow=c(1,1),las=1,cex.axis=1.5,cex.lab=2)
plot(X[1:30,4],Y[1:30],xlab=expression(X[4]),ylab="Y",type="n")
points(X[wh1,4],Y[wh1],col="red",pch=16,cex=1.5)
points(X[wh2,4],Y[wh2],col="springgreen4",pch=16,cex=1.5)
dev.off()




plot(X[1:30,4],Y[1:30],xlab=expression(X[4]),ylab="Y")


dat=data.frame(cbind(Y,X))
dat1=dat[1:30,]
dat2=dat[31:2030,]

tree1=rpart(Y~.,data=dat1)
print(tree1)
plot(tree1);text(tree1)

mpr=predict(tree1,dat2)
err=mpr-dat2$Y
v.bag.org=sqrt(mean(err^2))
print(v.bag.org)

nit=501
mpr.test=as.list(1:nit)
for(j in 1:nit){
cat(j,".. ")
srt=sample(1:30,repl=T)
mdat=dat1[srt,]
mtree=rpart(Y~.,data=mdat)
#print(mtree)
mpr=predict(mtree,dat2)
mpr.test[[j]]=mpr}

#for(j in 1:51){print(round(mpr.test[[j]][1:10],2))}

yy=rep(0,nit)
for(k in 1:nit){
cat(k,".. ")
mprfinal=rep(0,2000)
for(j in 1:k){
mprfinal=mprfinal+mpr.test[[j]]}
mprfinal=mprfinal/k
yy[k]=sqrt(mean((mprfinal-dat2$Y)^2))}

postscript("bagg.1.ps")
par(las=1)
plot(c(0,nit),range(c(v.bag.org,yy)),xlab="Number of Bootstrap Samples",ylab="Test Error",type="n")
abline(h=v.bag.org,lty=2,col="springgreen4")
lines(1:nit,yy,col="red",lwd=2)
text(50,v.bag.org+0.01,"Original Tree",col="springgreen4")
dev.off()

source("bagg.R")

nit=101;hm=20
test=bagg(20,nit)
range(test)

postscript("bagg.2.ps")
par(mfrow=c(4,5),mar=c(2,2,1,1),las=1)
for(j in 1:hm){
yy=test$z1[[j]]
v.bag.org=test$z2[j]
plot(c(0,nit),range(test),xlab="",ylab="",type="n")
abline(h=v.bag.org,lty=2,col="springgreen4")
lines(1:nit,yy,col="red",lwd=2)}
dev.off()



### boosting versus bagging

#boosting
hmp=200
x1=runif(hmp);x2=runif(hmp);xs=x1+x2
y1=rep(-1,hmp);y1[xs>1]=1

plot(c(0,1),c(0,1),xaxt="n",yaxt="n",xlab="",ylab="",type="n")
points(x1[xs>1],x2[xs>1],col="springgreen4",pch=16)
points(x1[xs<=1],x2[xs<=1],col="red",pch=16)
abline(c(1,-1),lwd=2)

mdat=data.frame(cbind(y=y1,x1,x2))
mdat$y=factor(mdat$y)
mdaty=rep(-1,hmp);mdaty[mdat$y=="1"]=1

wgts=rep(1,hmp)

nit=100
mtree.list=as.list(1:nit)
mpr.train=as.list(1:nit)
malphas=rep(0,nit)

for(j in 1:nit){
cat(j,".. ")
mtree=rpart(y~.,data=mdat,weights=wgts)
mcp=mtree$cptable[2,1]
mtree=prune.rpart(mtree,cp=mcp)
mtree.list[[j]]=mtree
mpr=predict(mtree,mdat)
py=rep(-1,hmp)
py[mpr[,2]>0.5]=1
mpr.train[[j]]= py
id=rep(1,hmp)
id[(py-mdaty)==0]=0
err=sum(wgts*id)/sum(wgts)
alpha=log((1-err)/err)
malphas[j]=alpha
wgts=wgts*exp(alpha*id)
wgts=wgts/mean(wgts)
}

xx1=seq(0,1,0.01)
xx2=seq(0,1,0.01)
x1x2=expand.grid(xx1,xx2)
x1x2=subset(x1x2,apply(x1x2,1,sum)<1.2)
x1x2=subset(x1x2,apply(x1x2,1,sum)>0.8)
newdat=data.frame(y=0,x1=x1x2[,1],x2=x1x2[,2])
hp=nrow(newdat)

mpy=as.list(1:nit)
for(j in 1:nit){
mpr=predict(mtree.list[[j]],newdat)
py=rep(-1,hp);py[mpr[,2]>0.5]=1
mpy[[j]]=py}

mprfinal=rep(0,hp)
for(j in 1:nit){mprfinal=mprfinal+malphas[j]*mpy[[j]]}
mprfinal=ifelse(mprfinal>0,1,-1)

newx1x2=matrix(nrow=98,ncol=2)
for(j in 2:99){
wh=(1:hp)[x1x2[,1]==xx1[j]]
wh2=order(-mprfinal[wh])[1]
newx1x2[j-1,1]=xx1[j]
newx1x2[j-1,2]=x1x2[wh[wh2],2]-0.005}

newx1x2=matrix(nrow=101,ncol=2)
newx1x2[,1]=xx1
for(j in 1:101){
wh=(1:hp)[x1x2[,1]==xx1[j]]
if(length(table(mprfinal[wh]))>1){
wh2=order(-mprfinal[wh])[1]
newx1x2[j,2]=x1x2[wh[wh2],2]-0.005}}

postscript("boost.grid.1.ps")
par(pty="s")
plot(c(0,1),c(0,1),xaxt="n",yaxt="n",xlab="",ylab="",type="n")
points(x1[xs>1],x2[xs>1],col="springgreen4",pch=16)
points(x1[xs<=1],x2[xs<=1],col="red",pch=16)
abline(c(1,-1),lwd=2)
dev.off()

postscript("boost.grid.2.ps")
par(pty="s")
plot(c(0,1),c(0,1),xaxt="n",yaxt="n",xlab="",ylab="",type="n")
points(x1[xs>1],x2[xs>1],col="springgreen4",pch=16)
points(x1[xs<=1],x2[xs<=1],col="red",pch=16)
abline(c(1,-1),lwd=2)
lines(newx1x2,col="blue",lwd=2)
dev.off()

# bagging

tree1=rpart(y~.,data=mdat)
print(tree1)
plot(tree1);text(tree1)

nit=1000
mtest=as.list(1:nit)
for(j in 1:nit){
cat(j,".. ")
srt=sample(1:hmp,repl=T)
mdat2=mdat[srt,]
mtree=rpart(y~.,data=mdat2)
mcp=mtree$cptable[2,1]
mtree=prune.rpart(mtree,cp=mcp)
#print(mtree)
mtest[[j]]=mtree}

mpy=as.list(1:nit)
for(j in 1:nit){
mpr=predict(mtest[[j]],newdat)
py=rep(-1,hp);py[mpr[,2]>0.5]=1
mpy[[j]]=py}

mprfinal=rep(0,hp)
for(k in 1:nit){
cat(k,".. ")
mprfinal=mprfinal+mpy[[k]]}
mprfinal=mprfinal/nit
mprfinal=ifelse(mprfinal>0,1,-1)

newx1x2=matrix(nrow=101,ncol=2)
newx1x2[,1]=xx1
for(j in 1:101){
wh=(1:hp)[x1x2[,1]==xx1[j]]
if(length(table(mprfinal[wh]))>1){
wh2=order(-mprfinal[wh])[1]
newx1x2[j,2]=x1x2[wh[wh2],2]-0.005}}
#newx1x2[1:21,2]=newx1x2[22,2]
newx1x2[1:19,2]=newx1x2[20,2]
newx1x2[78:101,2]=newx1x2[77,2]

#postscript("bagg.grid.1000.tree.ps")
postscript("bagg.grid.1000.stump.ps")
par(pty="s")
plot(c(0,1),c(0,1),xaxt="n",yaxt="n",xlab="",ylab="",type="n")
points(x1[xs>1],x2[xs>1],col="springgreen4",pch=16)
points(x1[xs<=1],x2[xs<=1],col="red",pch=16)
abline(c(1,-1),lwd=2)
lines(newx1x2,col="blue",lwd=2)
dev.off()

# random forests

#install.packages("randomForest")
library(randomForest)

mydat.rf=randomForest(y~.,data=mdat,importance=F,ntree=100,mtry=2)
rf.pred=predict(mydat.rf,newdat)
rfp=rep(-1,hp);rfp[rf.pred=="1"]=1

newx1x2=matrix(nrow=101,ncol=2)
newx1x2[,1]=xx1
for(j in 1:101){
wh=(1:hp)[x1x2[,1]==xx1[j]]
if(length(table(rfp[wh]))>1){
wh2=order(-rfp[wh])[1]
newx1x2[j,2]=x1x2[wh[wh2],2]-0.005}}
#newx1x2[1:20,]=newx1x2[21,]
#newx1x2[100,]=newx1x2[99,]

postscript("rf.grid.tree.ps")
par(pty="s")
plot(c(0,1),c(0,1),xaxt="n",yaxt="n",xlab="",ylab="",type="n")
points(x1[xs>1],x2[xs>1],col="springgreen4",pch=16)
points(x1[xs<=1],x2[xs<=1],col="red",pch=16)
abline(c(1,-1),lwd=2)
lines(newx1x2,col="blue",lwd=2)
dev.off()







write.table(round(mydat.rf$importance,5),file="imp.txt",sep=" ",quote=F)




mydat.rf=randomForest(Y~.,data=mydat,importance=T,ntree=10000)
write.table(round(mydat.rf$importance,5),file="imp.txt",sep=" ",quote=F)








###################################################






predict(mtree[[1]],newdat)






mpr=predict(tree1)


err=mpr-dat2$Y
v.bag.org=sqrt(mean(err^2))
print(v.bag.org)

nit=501
mpr.test=as.list(1:nit)
for(j in 1:nit){
cat(j,".. ")
srt=sample(1:30,repl=T)
mdat=dat1[srt,]
mtree=rpart(Y~.,data=mdat)
#print(mtree)
mpr=predict(mtree,dat2)
mpr.test[[j]]=mpr}

#for(j in 1:51){print(round(mpr.test[[j]][1:10],2))}

yy=rep(0,nit)
for(k in 1:nit){
cat(k,".. ")
mprfinal=rep(0,2000)
for(j in 1:k){
mprfinal=mprfinal+mpr.test[[j]]}
mprfinal=mprfinal/k
yy[k]=sqrt(mean((mprfinal-dat2$Y)^2))}

postscript("bagg.1.ps")
par(las=1)
plot(c(0,nit),range(c(v.bag.org,yy)),xlab="Number of Bootstrap Samples",ylab="Test Error",type="n")
abline(h=v.bag.org,lty=2,col="springgreen4")
lines(1:nit,yy,col="red",lwd=2)
text(50,v.bag.org+0.01,"Original Tree",col="springgreen4")
dev.off()

source("bagg.R")

nit=101;hm=20
test=bagg(20,nit)
range(test)

postscript("bagg.2.ps")
par(mfrow=c(4,5),mar=c(2,2,1,1),las=1)
for(j in 1:hm){
yy=test$z1[[j]]
v.bag.org=test$z2[j]
plot(c(0,nit),range(test),xlab="",ylab="",type="n")
abline(h=v.bag.org,lty=2,col="springgreen4")
lines(1:nit,yy,col="red",lwd=2)}
dev.off()













###########################











points(newdat[mprfinal==-1,-1],col="red",pch=15,cex=2)
points(newdat[mprfinal==1,-1],col="springgreen4",pch=15,cex=2)




points(xx1[2],x1x2[wh[wh2],2]-0.005,col="blue",pch=0)



newdat=data.frame(y=0,x1=x1x2[,1],x2=x1x2[,2])
mpr=predict(mtree.list[[1]],newdat)
hp=nrow(mpr)
py=rep(-1,hp);py[mpr[,2]>0.5]=1

par(pty="s")
plot(c(0,1),c(0,1),xaxt="n",yaxt="n",xlab="",ylab="",type="n")
points(x1[xs>1],x2[xs>1],col="springgreen4",pch=16)
points(x1[xs<=1],x2[xs<=1],col="red",pch=16)
abline(c(1,-1),lwd=2)

points(newdat[py==-1,-1],col="red",pch=15,cex=2)
points(newdat[py==1,-1],col="springgreen4",pch=15,cex=2)







points(newdat[,-1],col="blue")

points(newdat[py==-1,-1],col="red",pch=15,cex=2)
points(newdat[py==1,-1],col="springgreen4",pch=15,cex=2)




mclass=function(x1,x2){


points(newdat[,-1],col="blue")





mprfinal=rep(0,100)
for(j in 1:nit){mprfinal=mprfinal+malphas[j]*mpr.test[[j]]}
mprfinal=ifelse(mprfinal>0,1,-1)
1-sum(diag(table(mprfinal,mdat2y)))/100

yy=rep(0,nit)
for(k in 1:nit){
mprfinal=rep(0,10000)
for(j in 1:k){mprfinal=mprfinal+malphas[j]*mpr.test[[j]]}
mprfinal=ifelse(mprfinal>0,1,-1)
yy[k]=1-sum(diag(table(mprfinal,mdat2y)))/10000}















#################################################


zzz=rep(0,nit)
for(k in 1:nit){
zzz[k]=mpr.test[[k]][1]}


hist(zzz)
dat2$Y[1]

plot(yy)



par(las=1)
plot(c(0,nit),range(c(0.2,v.bag.org,yy,yy2)),xlab="Boosting Iteration",ylab="Test Error",type="n")
sq=seq(1,nit,2)
lines(sq,yy[sq],col="blue",lwd=2)
lines(sq,yy2[sq],col="red",lwd=2)
text(50,v1+0.01,"Single Stump",col="springgreen4")
abline(h=v.bag.org)











myrmvn=function(mu,sigma,hm=1,...){
n=length(mu)
if(sum((dim(sigma)-rep(n,2))^2)!=0) 
stop("Check the dimensions of mu and sigma!")
if(det(sigma)==0) stop("The covariance matrix is singular!")
a=t(chol(sigma))
z=matrix(rnorm(n*hm),nrow=n)
y=t(a%*%z+mu)
return(y)}

mu=rep(0,5)
sigma=matrix(0.95,5,5)+diag(0.05,5)
X=data.frame(myrmvn(mu,sigma,2030))
round(cor(X),2)

wh1=(1:2030)[X[,1]<=0.5]
wh2=(1:2030)[X[,1]>0.5]
Y=rep(0,2030)
Y[wh1]=rbinom(length(wh1),1,0.2)
Y[wh2]=rbinom(length(wh2),1,0.8)
table(Y)

dat=data.frame(cbind(Y,X))
dat$Y=factor(dat$Y)
dat1=dat[1:30,]
dat2=dat[31:2030,]
#dat.bak=dat
#dat.bak2=dat
mdat2y=rep(0,2000);mdat2y[dat2$Y=="1"]=1

tree1=rpart(Y~.,data=dat1,control=rpart.control(minsplit=2,minbucket=2,cp=0,maxdepth=3))
print(tree1)
plot(tree1);text(tree1)

mpr=predict(tree1,dat2)
py=rep(0,2000)
py[mpr[,2]>=0.5]=1
v.bag.org=1-sum(diag(table(py,mdat2y)))/2000
print(v.bag.org)



nit=101
mpr.test=as.list(1:nit)
mprob.test=as.list(1:nit)
for(j in 1:nit){
cat(j,".. ")
srt=sample(1:30,repl=T)
mdat=dat1[srt,]
mtree=rpart(Y~.,data=mdat,control=rpart.control(minsplit=2,minbucket=2,cp=0,maxdepth=3))
print(mtree)
mpr=predict(mtree,dat2)
mprob.test[[j]]=mpr[,2]
py=rep(0,2000)
py[mpr[,2]>0.5]=1
mpr.test[[j]]=py}

yy=rep(0,nit)
yy2=rep(0,nit)
for(k in 1:nit){
cat(k,".. ")
mprfinal=rep(0,2000)
mprobfinal=rep(0,2000)
for(j in 1:k){
mprfinal=mprfinal+mpr.test[[j]]
mprobfinal=mprobfinal+mprob.test[[j]]}
mprfinal=mprfinal/k
mprobfinal=mprobfinal/k
mprfinal=ifelse(mprfinal>=0.5,1,0)
mprobfinal=ifelse(mprobfinal>=0.5,1,0)
yy[k]=1-sum(diag(table(mprfinal,mdat2y)))/2000
yy2[k]=1-sum(diag(table(mprobfinal,mdat2y)))/2000}



par(las=1)
plot(c(0,nit),range(c(0.2,v.bag.org,yy,yy2)),xlab="Boosting Iteration",ylab="Test Error",type="n")
sq=seq(1,nit,2)
lines(sq,yy[sq],col="blue",lwd=2)
lines(sq,yy2[sq],col="red",lwd=2)
abline(h=v.bag.org)





















wh1b=(1:30)[dat1$X1<=0.5]
wh2b=(1:30)[dat1$X1>0.5]
mv1=1-(table(dat1$Y[wh1b])[1]+table(dat1$Y[wh2b])[2])/30

wh1c=(1:2000)[dat2$X1<=0.5]
wh2c=(1:2000)[dat2$X1>0.5]
mv2=1-(table(dat2$Y[wh1c])[1]+table(dat2$Y[wh2c])[2])/2000


abline(h=mv1,lty=2,col="springgreen4")
abline(h=mv2,lty=2,col="springgreen4")






..............


par(fig=c(0,0.65,0,1),pty="m")
persp(x1,x2,xprd,theta=30,phi=30,expand=0.8,col="lightblue",
xlab="girth",ylab="height",zlab="volume") -> theplot
points(trans3d(trees[,1],trees[,2],trees[,3],theplot),col=2,pch=16)
par(fig=c(0.65,1,0.5,1),new=T,las=1,cex.axis=0.6)
# this is from the MARS help file
Xp = matrix(sapply(trees[1:2], mean), nrow(trees), 2, byrow=TRUE)
xr = sapply(trees, range)
Xp1 = Xp; Xp1[,1] = seq(xr[1,1], xr[2,1], len=nrow(trees))
Xf = predict(fit1, Xp1)
plot(Xp1[ ,1], Xf, xlab=names(trees)[1], ylab="", type="l")
par(fig=c(0.65,1,0,0.5),new=T)
xr = sapply(trees, range)
Xp1 = Xp; Xp1[,2] = seq(xr[1,2], xr[2,2], len=nrow(trees))
Xf = predict(fit1, Xp1)
plot(Xp1[ ,2], Xf, xlab=names(trees)[2], ylab="", type="l")


postscript("mars1.ps")
persp(x1,x2,xprd,theta=30,phi=30,expand=0.8,col="lightblue",
xlab="girth",ylab="height",zlab="volume") -> theplot
points(trans3d(trees[,1],trees[,2],trees[,3],theplot),col=2,pch=16)
dev.off()



wh=(1:31)[fit1$fitted.values-trees[,3]>0]

persp(x1,x2,xprd,theta=-90,phi=-10,expand=0.8,col="lightblue",
xlab="girth",ylab="height",zlab="volume") -> theplot
for(j in 1:31){
aa=trans3d(trees[j,1],trees[j,2],fit1$fitted.values[j],theplot)
bb=trans3d(trees[j,1],trees[j,2],trees[j,3],theplot)
lines(c(aa$x,bb$x),c(aa$y,bb$y),lwd=2)}
points(trans3d(trees[,1],trees[,2],trees[,3],theplot),col="red",pch=16)
points(trans3d(trees[wh,1],trees[wh,2],trees[wh,3],theplot),col="lightpink",pch=16)
points(trans3d(trees[,1],trees[,2],fit1$fitted.values,theplot),col="black",pch=16)


postscript("mars2.ps")
persp(x1,x2,xprd,theta=30,phi=30,expand=0.8,col="lightblue",
xlab="girth",ylab="height",zlab="volume") -> theplot
for(j in 1:31){
aa=trans3d(trees[j,1],trees[j,2],fit1$fitted.values[j],theplot)
bb=trans3d(trees[j,1],trees[j,2],trees[j,3],theplot)
lines(c(aa$x,bb$x),c(aa$y,bb$y),lwd=2)}
points(trans3d(trees[wh,1],trees[wh,2],trees[wh,3],theplot),col="lightpink",pch=16,cex=1)
#points(trans3d(trees[,1],trees[,2],fit1$fitted.values,theplot),col="black",pch=16,cex=1)
points(trans3d(trees[-wh,1],trees[-wh,2],trees[-wh,3],theplot),col="red",pch=16,cex=1)
dev.off()

lm1=lm(Volume~Girth+Height,data=trees)
xlm1=matrix(predict(lm1,x),ncol=21)




postscript("lm1.ps")
persp(x1,x2,xprd,theta=30,phi=30,expand=0.8,col="lightblue",
xlab="girth",ylab="height",zlab="volume") -> theplot
for(j in 1:31){
aa=trans3d(trees[j,1],trees[j,2],fit1$fitted.values[j],theplot)
bb=trans3d(trees[j,1],trees[j,2],trees[j,3],theplot)
lines(c(aa$x,bb$x),c(aa$y,bb$y),lwd=2)}
points(trans3d(trees[wh,1],trees[wh,2],trees[wh,3],theplot),col="lightpink",pch=16,cex=1)
#points(trans3d(trees[,1],trees[,2],fit1$fitted.values,theplot),col="black",pch=16,cex=1)
points(trans3d(trees[-wh,1],trees[-wh,2],trees[-wh,3],theplot),col="red",pch=16,cex=1)
dev.off()







persp(x1,x2,xprd,theta=30,phi=30,expand=0.8,col="lightblue",
xlab="girth",ylab="height",zlab="volume") -> theplot
points(trans3d(trees[,1],trees[,2],fit1$fitted.values,theplot),col="black",pch=16,cex=0.8)







fit1=mars(trees[,-3],trees[3])
fit2=lm(Volume~Girth+Height,data=trees)

plot(trees$Volume-predict(fit2),
drop(residuals(fit1)))

residuals(fit2)

trees$Volume-predict(fit2)

drop(residuals(fit1))


zz=abs(residuals(fit2))-abs(residuals(fit1))

persp(x1,x2,diag(0,21),theta=30,phi=5,zlim=c(-6,6),col="lightblue",
xlab="girth",ylab="height",zlab="residuals") -> theplot
points(trans3d(trees[,1],trees[,2],zz,theplot),col=2,pch=16)



points(trans3d(trees[,1],trees[,2],trees[,3],theplot),col=2,pch=16)
